/* stat.c */

#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include "pragmas.h"

FILE *in, *out, *debugout, *data;

static char version[]  = "9.14";
char configfile[256]    = "stat.cfg";
char infile[256]        = "trap.fbi";
char outfile[256]       = "stat.out";
char debugfile[256]     = "debug.out";
char datafile[256]      = "stat.dat";

long traplength;         // length of trap file 
long numlines = 0;       // number of lines in trap file.

char usersort      = 'A', /* these are the various sort options... */
     networksort   = 'A',
     protosort     = 'A';

char color         = 1, /* this is all configurable stuff. */
     coloredbars   = 1,
     debug	   = 0,
     uptime        = 1,
     totaluse      = 1,
     avuse         = 1,
     avsect	   = 1,
     trapsect	   = 1,
     protosect	   = 1,
     hourusage	   = 1,
     dayusage	   = 1,
     twolineuser   = 1,
     onetimecaller = 1,
     usersect	   = 1,
     nodesect      = 1,
     awards        = 1,
     msgstats	   = 0,
     oldgraph      = 0;

long seeuser       = 1;

char *tempname;        /* name of temp output file */

char line[257],          // line that we are processing
     word1[257],         // first word of said line
     word2[257],         // second word.
     lword1[257],        // first word of last line
     lword2[257],        // second word
     *text,              // pointer to text of message
     detect=0;

char mn[4];              // month of current line...string...

int  chour[24],          /* calls per hour  (not shown...) */
     cday[7],            // also not shown
     callbaud[16],       // also not shown
     numusr=0,        /* number of users that have called in this section */
     numnet=0,        // number of nodes.
     numproto=0,      // number of protocols.
     numexcl=0,       // number of excluded names.
     numweek=0,
     curweek=0,         /* current week */
     j=0,
     i=0;

		// number of seconds since 00:00:00 on January 1, 1970 (GMT)).
long date=0,          /* date of curent line */
     ldate=0,         /* date of last line */
     fdate=0,         /* date of first line. */
     weekstart=0,     /* start of current week */
     downtime=0,
     networktime=0,
     applictime=0,
     usedhour[24],
     usedbaud[16],
     usedday[7],
     usedtime=0,
     logins=0,
     hangups=0,
     chreq=0,
     crash=0,
     menter=0,
     mread=0,
     anon=0,
     newusr=0,
     wcup=0,
     wcdown=0,
     net=0,
     netcall=0,
     ofetch=0,
     incorp=0;

struct tm tfirst, tlast, t;     /* new time stuff. */

struct usr {                               /* The stuff for inividual users */
     char name[31];
     unsigned excl:1;
     unsigned new:1;
     long timeon;
     unsigned calls,
	      carrierd,
	      crash,
	      upload,
	      download,
	      umread,
	      umenter,
	      anon,
	      uchats;
     };

struct usr *user;

struct net {
     char name[31];
     unsigned excl:1;
     long timeon,
	  calls,
	  busy,
	  nmenter,
	  nmread,
	  nmduplicate,
	  nmexpired,
	  files,
	  rooms,
	  ofetch,
	  incorp;
	  };

struct net *network;

struct protocol {                /* protocol stuff. */
     char name[31];
     unsigned excl:1;
     long down;
     long up;
     };

struct protocol *proto;

struct exclusion {char excl[31];};

struct exclusion *excltbl;

struct weekly {long usedtime;};

struct weekly *utimetbl;

static char *KEYWORDS[] = {
     "Login",             /* 0  Normal Login. followed by username */
     "New",               /* 1  Newuser Login. followed by username */
     "NetLogin",          /* 2  Net call in */
     "NetCallout",        /* 3  Net call out */
     "Carrier-Detect",    /* 4  Carrier Detected. followed by baud rate */
     "Chat",              /* 5  Chat request */
     "Citadel",           /* 6  Citadel terminated or started */
     "DragCit",  /* 7  Old. Citadel terminated or started...i forget which. */
     "Logout",            /* 8  Logout.  followed by username */
     "Carrier",           /* 9  Carrier dropped, used. */
     "Carrier-Loss",      /* 10 Also carrier dropped. not used, though. */
     "Anonymous",         /* 11 anonymous message. */
     "Archive-view",      /* 12 View an arj file. */
     "Fetching",          /* 13 offline fetch. followed by "For [node]" */
     "Local",             /* 14 followed by "Net 6.9 Incorporation" */
     "Run",               /* 15 Run Application. */
     "End"                /* 16 End Application. */
     };

static char *NETKEYWORDS[] = {
	"NetDial",
	"Carrier-loss",
	"Carrier",
	"NetLogout"
	};

static char *COLORS[] = {
     "b",                                   /* Red     */
     "c",                                   /* Green   */
     "d",                                   /* Yellow  */
     "e",                                   /* Blue    */
     "f",                                   /* Magenta */
     "g",                                   /* Cyan    */
     "h",                                   /* White   */
     "3a",                                 /* light gray     */
     "3b",                                 /* bright red     */
     "3c",                                 /* bright green   */
     "3d",                                 /* bright yellow  */
     "3e",                                 /* bright blue    */
     "3f",                                 /* bright magenta */
     "3g",                                 /* bright cyan    */
     "3h"                                  /* bright white   */
     };

static char *bauds[] = {
     "300",
     "1200",
     "2400",
     "4800",
     "7200",
     "9600",
     "12000",
     "14400",
     "16800",
     "19200",
     "28800",
     "38400",
     "57600",
     "115200",
     "230400",
     "con"
     };

static char *bauds2[] = {
     "(300)",
     "(1200)",
     "(2400)",
     "(4800)",
     "(7200)",
     "(9600)",
     "(12000)",
     "(14400)",
     "(16800)",
     "(19200)",
     "(28800)",
     "(38400)",
     "(57600)",
     "(115200)",
     "(230400)",
     "(con)"
     };

static char *DAYS[] = {
     "Sunday",
     "Monday",
     "Tuesday",
     "Wednesday",
     "Thursday",
     "Friday",
     "Saturday",
     "Unknown"
     };

void main(int argc, char *argv[]);
int  readcfg(void);
int  chkexcl (char *nym);
void output(void);
void debug_out(void);
void login(void);
void netlogin(char type);
void getline(void);
void parseargs(int argc, char *argv[]);
void filter(char *argv[]);
int  usortfunc(const void *this, const void *that);
int  nsortfunc(const void *this, const void *that);
int  psortfunc(const void *this, const void *that);
void msgstat(void);

/****************************************************************************/
/* main() Sets up the files, does the main loop, and exits. Big deal.       */
/****************************************************************************/
void main(int argc, char *argv[])
{
   printf("\n"
	  "STAT trap.fbi statistics generator.\n"
	  "Version %s (%s %s)\n"
	  "\n"
	  "               By\n"
	  "Captain James T Kirk (Audin Malmin)\n"
	  "              and\n"
	  "   Counselor @ Blind Man's Bluff.\n"
	  "\n",
	  version, __DATE__, __TIME__);

   if (argc < 3)
   {
       printf("Usage: %s trap_file output_file [options]\n"
	      "\n"
	      "    trap_file: the path and name of Citadel's Trapfile.\n"
	      "  output_file: path and filename for output.\n"
	      "      options:\n"
	      "      -1: One time caller section. -1+ = included, -1- = excluded.\n"
	      "      -B: Graph bars. -B+ = multi-colored bars (default), -B- = white bars.\n"
	      "      -C: Color in output file. -C+ = on (default), -C- = off.\n"
	      "      -D: Debug mode.\n"
	      "      -U: Two line userlist.  -U+ = on (default), -U- off.\n"
	      "     -#n: Only users with > n calls get listed in userlist. (-#1 default)\n"
	      "   -Sunp: Sort(user)(network)(protocol)\n"
	      "          user:\n"
	      "               A)lphabetic, T)ime, CalL)s, Messages R)ead, Messages E)ntered,\n"
	      "               P)ost/Call Ratio, U)ploads, D)ownloads, C)hat Requests.\n"
	      "       network:\n"
	      "               A)lphabetic, B)usy Signals, C)alls, Messages D)uplicated,\n"
	      "               Messages E)xpired, P)osts, Messages R)ead, T)ime.\n"
	      "      protocol:\n"
	      "               A)lphabetic, U)ploads, D)ownloads.\n"
	      "          eg: \"-Sacu\"  for Alpha, calls, uploads.\n",
	      argv[0]);
       exit(-1);
   }

   readcfg();
   parseargs(argc, argv);

   if ((in = fopen(argv[1], "r")) == NULL)
   {
       printf("\n Can't open \"%s\" for input.\n", argv[1]);
       exit(-1);
   }

   tempname = tmpnam(NULL);

   if ((out = fopen(tempname, "wt")) == NULL)
   {
       printf("\n Can't open \"%s\" for output.\n", tempname);
       fcloseall();
       exit(-1);
   }

   traplength = filelength(fileno(in));

   setvbuf(in, NULL, _IOFBF, 4096);
//     setvbuf(in, NULL, _IOFBF, 8192);

   for(i=0; i<24; i++)
      {
      chour[i]    = 0;
      usedhour[i] = 0;
      }

   for(i=0; i<7; i++)
      {
      cday[i]      = 0;
      usedday[i]   = 0;
      }

   for(i=0; i<16; i++)
      {
      usedbaud[i]=0;
      callbaud[i]=0;
      }

   word1[0]  = '\0';
   word2[0]  = '\0';
   lword1[0] = '\0';
   lword2[0] = '\0';

   printf("Free heap: %lu bytes\n", (unsigned long) coreleft());

   printf("Reading \"%s\".\n", argv[1]);

					      /* calloc first struct member */
   if(!(user = (void *)calloc(1, sizeof(struct usr))))
      {
      printf("Out of memory...try supershelling first...\n");
      exit(-1);
      }

   if(!(proto = (void *)calloc(1, sizeof(struct protocol))))
     {
     printf("Out of memory...try supershelling first...\n");
     exit(-1);
     }

   if(!(network = (void *)calloc(1, sizeof(struct net))))
     {
     printf("Out of memory...try supershelling first...\n");
     exit(-1);
     }
/*
   if(!(utimetbl = (void *)calloc(1, sizeof(struct weekly))))
     {
     printf("Out of memory...try supershelling first...\n");
     exit(-1);
     }

   utimetbl[curweek].usedtime = 0;
 */
   while(!feof(in))                              /* main loop starts here!! */
   {
       getline();

       for (i=0; i<16; i++)
           if (stricmp(word1, KEYWORDS[i])==0)
               break;

       switch(i)
       {
       case 0:   /* normal Login */
	       login();
	       break;
       case 1:   /* new user login */
	       newusr++;
	       login();
	       break;
       case 2:   /* net Login (not dialout) */
	       net++;
	       netlogin(1);
	       detect=0;
               break;
       case 3:   /* Net Dialout */
	       netcall++;
	       netlogin(1);
	       detect=0;
               break;
       case 4:   /* Carrier detect (baud) */
	       for(j=0; j<15; j++)
		   {
		   if(stricmp(word2, bauds2[j])==0)
		       break;
		   }
	       detect=1;
	       break;
       case 5:   /* Chat request */
	       chreq++;
	       detect=0;
               break;
       case 6:   /* Citadel Started */
	       if(stricmp(word2, "Started")==0)
		 {
		 downtime += date - ldate;
		 if(stricmp(lword2, "Terminated") != 0)
		   {
		   crash++;
		   printf("");
		   }
		 }
	       break;
       case 7:   /* "DragCit Started", unused */
       case 8:   /* "Logout", detected in the login() function */
       case 9:   /* "Carrier" Dropped, in login() funct */
      case 10:   /* "Carrier-Loss", unused */
	       break;
      case 11:   /* Anonymous message */
	       anon++;
	       break;
      case 13:   /* offline fetch */
	       ofetch++;
	       netlogin(2);
	       break;
      case 16:   /* End of application run */
	       if(stricmp(word2, "Application")==0)
		 {
		 applictime += date - ldate;
//		 printf("End application...applictime: %ld\n", applictime);
		 }
	       break;

      default:   /* a weird one.  (one we don't know how to handle) */
	       detect=0;
	       break;
       }
   }

   printf("Free heap: %lu bytes\n", (unsigned long) coreleft());
   printf("Size of usertable: %ld bytes.", numusr * sizeof(struct usr) / 8);

   if(debug)
     debug_out();

   /* do the sorting thing... */
   printf("\nSorting users by %c.\n", usersort);
   qsort(user, numusr, sizeof(struct usr), usortfunc);

   printf("Sorting protocols by %c.\n", protosort);
   qsort(proto, numproto, sizeof(struct protocol), psortfunc);

   printf("Sorting nodes by %c.\n", networksort);
   qsort(network, numnet, sizeof(struct net), nsortfunc);

   printf("Writing \"%s\"\n", argv[2]);

   output();

/*   if(msgstats)
	msgstat();
*/

   free(user);
   free(proto);
   free(network);
   fcloseall();

   if(!color)
     {
     printf("Filtering out color.\n");
     filter(argv);
     unlink(tempname);
     }
   else
     {
     unlink(argv[2]);
     rename(tempname, argv[2]);
     }

}

/****************************************************************************/
/* getline()   Gets a line from the trap file and sets the date and ldate   */
/*             Also sets word1, and text.                                   */
/****************************************************************************/
void getline(void)
{
   int loop;
   int loop1;
   static char *mnts[] = {                                /* All the months */
		   "Jan", "Feb", "Mar", "Apr", "May", "Jun",
		   "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

   ldate=date;

   fgets(line, 256, in);                                    /* Get the line */
   line[strlen(line)-1]='\0';                            /* snip the return */

   numlines++;

   weekstart = t.tm_wday;

   if(debug)
      printf("coreleft: %lu bytes, farheap: %lu bytes, line: %ld\r",
	      coreleft(), farcoreleft(), numlines);

/*   if(numlines > 35500L)
	printf("line: %s, %ld", line, numlines);
   else
	printf("line: %ld\r", numlines);
*/
   sscanf(line, "%d%3s%d %d:%d:%d", &(t.tm_year), mn, &(t.tm_mday),
	   &(t.tm_hour), &(t.tm_min), &(t.tm_sec));

   for (loop=0; loop<12; loop++)
       if (strcmp(mn, mnts[loop])==0)
	   t.tm_mon=loop;

   if (!fdate)
       memcpy(&tfirst, &t, sizeof(t));

   memcpy(&tlast, &t, sizeof(t));

   date=mktime(&t);

   if (!fdate)
       {
       fdate=date;
       }
/*
   if(t.tm_wday == 0 && weekstart == 6)
	{
	curweek++;

	if((utimetbl = (void *)realloc((void *)utimetbl, sizeof(struct weekly) * curweek)) == NULL)
	   {
	   printf("Out of memory.  Unable to store week %d.", curweek);
	   }

	utimetbl[curweek].usedtime = 0;

	printf("\nSunday!\n");
	printf("Previous week's time = %ld\n", utimetbl[curweek - 1].usedtime);
	printf("Current weeks number = %d, %d\n", curweek);
	printf("This weeks time      = %ld\n", utimetbl[curweek].usedtime);

	for (loop1=0; loop1<curweek; loop1++)
	   {
	   printf("Week # %d == %ld\n", loop1, utimetbl[loop1].usedtime);
	   }
	}
*/

   text=(line + 19);                                /* set the text segment */

   lword1[0] = '\0';
   lword2[0] = '\0';

   strcpy(lword1, word1);
   strcpy(lword2, word2);

   word1[0] = '\0';
   word2[0] = '\0';

   sscanf(text, "%s %s", word1, word2);                    /* Get the words */

}

/****************************************************************************/
/* login() Handles all things produced while a user is logged in.           */
/****************************************************************************/
void login(void)
{
   int me, mr, logout=0;
   long tin, tout;       /* time in, time out */
   int usrnum, lp, protonum;
   char *nym;

   printf("");

   tin=date;
   me    =0;
   mr    =0;
   logins++;

   if (stricmp(word1, KEYWORDS[1])==0)
       nym=(text+9);
   else
       nym=(text+6);

   for (lp=0, usrnum=-1; lp<numusr; lp++)
       {
/*       printf("user.name: %s\n"
	      "nym      : %s\n"
	      "lp       : %d\n", user[lp].name+1, nym, lp); */
       if (stricmp(nym, user[lp].name+1)==0)
           usrnum=lp;
       }

   if (usrnum==-1)
   {
       numusr++;
       usrnum=numusr-1;

			   /* realloc for new user, only as many as we need */
       if(!(user = (void *)realloc((void *)user, numusr * sizeof(struct usr))))
	 {
	 printf("Damn...I ran out of memory...  you'd better try a supershell.\n");
	 exit(-1);
	 }

       strcpy(user[usrnum].name, nym);

       if (stricmp(word1, KEYWORDS[1]) == 0)
           user[usrnum].new = 1;
       else
           user[usrnum].new = 0;

       user[usrnum].excl     = chkexcl(nym);
       user[usrnum].timeon   = 0;
       user[usrnum].calls    = 0;
       user[usrnum].carrierd = 0;
       user[usrnum].upload   = 0;
       user[usrnum].download = 0;
       user[usrnum].umread   = 0;
       user[usrnum].umenter  = 0;
       user[usrnum].anon     = 0;
       user[usrnum].crash    = 0;
       user[usrnum].uchats   = 0;
   }

   chour[t.tm_hour]++;

   cday[t.tm_wday]++;

   while(!feof(in) && !logout)  /* loop starts here */
   {
       getline();

       for (i=5; i<12; i++)
	   if (stricmp(word1, KEYWORDS[i])==0)
	       break;

       switch(i)
       {
       case 5: /* chat */
	       user[usrnum].uchats++;
	       chreq++;
	       break;
       case 6: /* Citadel Started?  yikes!  a crash! */
	       if(stricmp(word2, "Started")==0)
		 {
		 downtime += date - ldate;
		 crash++;
		 user[usrnum].crash++;
		 printf("");
		 }
	       logout=1;
	       tin=date;
	       break;
       case 7: /* Dragcit ...  something...  not really used. */
	       logout=1;
	       tin=date;
	       break;
       case 8: /* Logout */
	       if(stricmp(text+strlen(word1), user[usrnum].name) != 0)
		 {
		 strcpy(user[usrnum].name, text+strlen(word1));
		 }

	       if (!feof(in)) /* get messages entered */
	       {
		   getline();
                   sscanf(text, "%s %d", word1, &me);
               }
	       if (!feof(in)) /* get messages read */
	       {
		   getline();
                   sscanf(text, "%s %d", word1, &mr);
               }
	       logout=1;
	       break;
       case 9: /* Carrier Dropped */
	       if(stricmp(word2, "dropped")==0)
		 {
		 hangups++;
		 user[usrnum].carrierd++;
		 }
	       break;
       case 10: /* Carrier-Loss */
	       break;
       case 11:
		anon++;
		user[usrnum].anon++;
		break;
       case 16:
		break;
       default:
	       if(stricmp(word2, "download")==0)
	       {
		   wcdown++;
		   user[usrnum].download++;

		   for(lp=0, protonum=-1; lp<numproto; lp++)
		      if(stricmp(word1, proto[lp].name)==0)
			protonum=lp;

		   if(protonum==-1)
		   {
		     numproto++;
		     protonum=numproto-1;

		     if(!(proto = (void *)realloc((void *)proto, numproto * sizeof(struct protocol))))
			{
			printf("Out of memory...  saving protocol %s\n", word1);
			exit(1);
			}
		
		     strcpy(proto[protonum].name, word1);

		     proto[protonum].down = 0;
		     proto[protonum].up = 0;
		   }
		   proto[protonum].down++;
	       }
	       else
		   if(stricmp(word2, "upload")==0)
		       {
		       wcup++;
		       user[usrnum].upload++;

		       for(lp=0, protonum=-1; lp<numproto; lp++)
			 if(stricmp(word1, proto[lp].name)==0)
			   protonum=lp;

		       if(protonum==-1)
			 {
			 numproto++;
			 protonum=numproto-1;

			 if(!(proto = (void *)realloc((void *)proto, numproto * sizeof(struct protocol))))
				{
				printf("Out of memory...  saving protocol %s\n", word1);
				exit(1);
				}

			 strcpy(proto[protonum].name, word1);
			 proto[protonum].down = 0;
			 proto[protonum].up = 0;
			 }
		       proto[protonum].up++;
		       }
	       break;
       }

   }

   tout                   = date;
   usedtime              += (tout-tin);
//   utimetbl[curweek].usedtime	 += (tout-tin);
//   printf("\nutimetbl[curweek].usedtime = %ld\n", utimetbl[curweek].usedtime);
   usedhour[t.tm_hour]   += (tout-tin);
   usedday[t.tm_wday]    += (tout-tin);

   if(detect)
   {
       callbaud[j]++;
       usedbaud[j]       += (tout-tin);
       detect=0;
   }
   else
   {
       callbaud[15]++;
       usedbaud[15]       += (tout-tin);
   }

   menter                += me;
   mread                 += mr;
   user[usrnum].timeon   += (tout-tin);
   user[usrnum].calls++;

   if(user[usrnum].calls > 1 && user[usrnum].new == 1)
      user[usrnum].new = 0;

   user[usrnum].umread   += mr;
   user[usrnum].umenter  += me;
}

/****************************************************************************/
/* network() handles network stuff.                                         */
/****************************************************************************/
void netlogin(char type)
{
   int i, me, mr, mx, md, logout;
   long tin, tout;
   int netnum, lp;
   char *nym;

   printf("");
   tin = date;
   me  = 0;
   mr  = 0;
   mx  = 0;
   md  = 0;
   logout = 0;

   if(type==1)
     nym=text+strlen(word1)+1;
   else
     if(type==2)
       {
       nym=text+14;
       nym[strlen(nym)-1] = '\0'; /* kill the end quotation mark */
       }

   for (lp=0, netnum=-1; lp<numnet; lp++)
       if (stricmp(nym, network[lp].name)==0)
	   netnum=lp;

   if (netnum==-1)
   {
       numnet++;
       netnum=numnet-1;

       if(!(network = (void *)realloc((void *)network, numnet * sizeof(struct net))))
	 {
	 printf("Crap, out of memory. ...saving node %s\n", nym);
	 exit(1);
	 }

       strcpy(network[netnum].name, nym);

       network[netnum].timeon      = 0;
       network[netnum].calls       = 0;
       network[netnum].busy	   = 0;
       network[netnum].nmread      = 0;
       network[netnum].nmenter     = 0;
       network[netnum].nmduplicate = 0;
       network[netnum].nmexpired   = 0;
       network[netnum].files	   = 0;
       network[netnum].rooms	   = 0;
       network[netnum].ofetch	   = 0;
       network[netnum].incorp	   = 0;
   }

   if(type==2)
     {
     network[netnum].ofetch++;
     return;
     }

   while(!logout && !feof(in))
     {
     getline();

     for(i=0; i<4; i++)
	  if(stricmp(word1, NETKEYWORDS[i])==0)
	    break;

     switch(i)
     {
     case 0:
	    if(stricmp(word2, "(busy)")==0)
	      {
	      network[netnum].busy++;
	      logout=1;
	      }
	    break;
     case 1:
	    break;
     case 2:
	    hangups++;
	    break;
     case 3:
	    if(stricmp(text+10+strlen(network[netnum].name), " (succeeded)")==0)
	    {
	      if(!feof(in))
	      {
		getline();
		sscanf(text, "%s %d", word1, &me);
	      }
	      if(!feof(in))
	      {
		getline();
		sscanf(text, "%s %d", word1, &mr);
	      }
	      if(!feof(in))
	      {
		getline();
		sscanf(text, "%s %d", word1, &mx);
	      }
	      if(!feof(in))
	      {
		getline();
		sscanf(text, "%s %d", word1, &md);
	      }
	    }
	    logout=1;
	    break;
     default:
	    break;
     }
     }

   tout = date;
   networktime += (tout-tin);

   network[netnum].timeon      += (tout-tin);
   network[netnum].calls++;
   network[netnum].nmenter     += me;
   network[netnum].nmread      += mr;
   network[netnum].nmduplicate += md;
   network[netnum].nmexpired   += mx;

}

/****************************************************************************/
/* output() Have fun with this part, it could be made to say just about     */
/*          anything you want.                                              */
/****************************************************************************/
void output(void)
{
   float temp;
   int loop1, loop2;
   int j;

   fprintf(out, "5");

   if(uptime)
     {
     fprintf(out,"3e      From                  To               Total time\n");
     fprintf(out,"a       0\n");
       fprintf(out,"%2d3a/0%02d3a/0%d %2d3a:0%02d3a:0%02d -- %2d3a/0%02d3a/0%d %2d3a:0%02d3a:0%02d = %2ld days3a,0 %2ld3a:0%02ld3a:0%02ld\n \n",
	   tfirst.tm_mon+1, tfirst.tm_mday, tfirst.tm_year,
	   tfirst.tm_hour, tfirst.tm_min, tfirst.tm_sec,
	   tlast.tm_mon+1, tlast.tm_mday, tlast.tm_year,
	   tlast.tm_hour, tlast.tm_min, tlast.tm_sec,
	   (date-fdate)/60/60/24,
	   (date-fdate)/60/60 % 24,
	   (date-fdate)/60 % 60,
	   (date-fdate) % 60);
     }

   if(totaluse)
     {
     fprintf(out,"3e    Used time         Network time     Application time   Total busy time\n");
       fprintf(out,"a      0\n");
     fprintf(out,"%2ld days3a,0 %2ld3a:0%02ld3a:0%02ld  %2ld days3a,0 %2ld3a:0%02ld3a:0%02ld  %2ld days3a,0 %2ld3a:0%02ld3a:0%02ld  %2ld days3a,0 %2ld3a:0%02ld3a:0%02ld\n",
	   (usedtime)/60/60/24,
	   (usedtime)/60/60 % 24,
	   (usedtime)/60 % 60,
	   (usedtime) % 60,
	   (networktime)/60/60/24,
	   (networktime)/60/60 % 24,
	   (networktime)/60 % 60,
	   (networktime) % 60,
	   (usedtime+applictime)/60/60/24,
	   (usedtime+applictime)/60/60 % 24,
	   (usedtime+applictime)/60 % 60,
	   (usedtime+applictime) % 60,
	   (usedtime+networktime)/60/60/24,
	   (usedtime+networktime)/60/60 % 24,
	   (usedtime+networktime)/60 % 60,
	   (usedtime+networktime) % 60);
     fprintf(out,"\n");
     }

   if(avuse)
     {
     fprintf(out,"3eAverage Use  Average Timea/eCall\n");
     fprintf(out,"a  0\n");
     fprintf(out,"  %5.02f3a%%0        %2ld3a:0%02ld3a:0%02ld\n",
	     (float)usedtime/(date-fdate)*100,
	     (usedtime/logins)/60/60 % 24,
	     (usedtime/logins)/60 % 60,
	     (usedtime/logins) % 60);
     fprintf(out,"\n");
     }

   if(avsect)
     {
     temp = (float)(date-fdate)/60/60/24;

   fprintf(out,"3eAverages pera:e          call       day     period\n");
	 fprintf(out,"a                         \n");

     fprintf(out,  "eCallsa..............:  0   %8.02f  %8d\n",
				(float)logins/((float)(date-fdate)/60/60/24),
						   logins);
   if(menter || mread || anon)
     fprintf(out,"3eMessagesa...........:0\n");
   if(menter)
     fprintf(out,"3e   Entereda.........:0 %8.3f  %8.3f  %8ld\n",
						   ((float)menter/logins),
						   ((float)menter/temp),
						   menter);
   if(mread)
     fprintf(out,"3e   Reada............:0 %8.3f  %8.3f  %8ld\n",
						   ((float)mread/logins),
						   ((float)mread/temp),
						   mread);
   if(anon)
     fprintf(out,"3e   Anonymousa.......:0 %8.3f  %8.3f  %8ld\n",
						   ((float)anon/logins),
						   ((float)anon/temp),
						   anon);
   if(wcup || wcdown)
     fprintf(out,"3eFilesa..............:0\n");
   if(wcup)
     fprintf(out,"3e   Uploadeda........:0 %8.3f  %8.3f  %8ld\n",
						   ((float)wcup/logins),
						   ((float)wcup/temp),
						   wcup);
   if(wcdown)
     fprintf(out,"3e   Downloadeda......:0 %8.3f  %8.3f  %8ld\n",
						   ((float)wcdown/logins),
						   ((float)wcdown/temp),
						   wcdown);
   if(chreq)
     fprintf(out,"3eChatsa..............:0 %8.3f  %8.3f  %8ld\n",
						   ((float)chreq/logins),
						   ((float)chreq/temp),
						   chreq);
   if(hangups)
     fprintf(out,"3eDropped Carriersa...:0 %8.3f  %8.3f  %8ld\n",
						   ((float)hangups/logins),
						   ((float)hangups/temp),
						   hangups);
   if(newusr)
     fprintf(out,"3eNew Usersa..........:0 %8.3f  %8.3f  %8ld\n",
						   ((float)newusr/logins),
						   ((float)newusr/temp),
						   newusr);
   if(net || netcall)
     fprintf(out,"3eNetworkinga.........:0\n");
   if(netcall)
     fprintf(out,"3e    Net calloutsa...:0 %8.3f  %8.3f  %8ld\n",
						   ((float)netcall/logins),
						   ((float)netcall/temp),
						   netcall);
   if(net)
     fprintf(out,"3e    Net callinsa....:0 %8.3f  %8.3f  %8ld\n",
						   ((float)net/logins),
						   ((float)net/temp),
						   net);
   if(net || netcall)
     fprintf(out,"3e    Total Networksa.:0 %8.3f  %8.3f  %8ld\n",
						   ((float)(net+netcall)/logins),
						   ((float)(net+netcall)/temp),
						   (net+netcall));
   if(ofetch)
     fprintf(out,"3e    Offline fetchesa:0 %8.3f  %8.3f  %8ld\n",
						   ((float)ofetch/logins),
						   ((float)ofetch/temp),
						   ofetch);
   if(crash)
     fprintf(out,"3eCrashesa............:0 %8.3f  %8.3f  %8ld\n",
						   ((float)crash/logins),
						   ((float)crash/temp),
						   crash);
   fprintf(out,"\n");
     } /* end avsection */

   if(trapsect)
     {
     fprintf(out,"3eTrapfile\n");
       fprintf(out,"a\n");
       fprintf(out,"eSizea.............:0 %ld bytes\n", traplength);
     fprintf(out,"3eLinesa............:0 %ld\n", numlines);
     fprintf(out,"3eAverage lines/daya:0 %f\n", (float)numlines/temp);
     fprintf(out,"\n");
     }

   if(protosect)
     {
     fprintf(out,"3e  Baud logins              time  usage     Protocol                     up  down\n");
       fprintf(out,"a          0\n");

     i = 0;
     j = 0;
     while(j<numproto || i<16)
       {
       if(i<16) /* are there any bauds left? */
	 {
	 while(!callbaud[i] && i<16) /* scroll through bauds untill we find a used one */
		i++;

	 fprintf(out,"%6s %6d %2ld days3a,0 %2ld3a:0%02ld3a:0%02ld %5.02f3a%%", bauds[i], callbaud[i],
		(usedbaud[i])/60/60/24,
		(usedbaud[i])/60/60 % 24,
		(usedbaud[i])/60 % 60,
		(usedbaud[i]) % 60,
		((float)usedbaud[i]/(float)(usedtime)*100));
	 }
       else /* out of baud rates...just put in spaces to line up protocol. */
	 fprintf(out,"                    3a");

       if(j<numproto) /* any protocols left? */
	  fprintf(out,"  0  %-25.25s %5ld %5ld\n",
		      proto[j].name, proto[j].up, proto[j].down);
       else /* nope...just put in a CR */
	  fprintf(out,"\n");

       i++;
       j++;
       }

     fprintf(out, "\n");
     }

   if(hourusage)
     {
     fprintf(out,"3ePercent Usage a(eby houra)\n");
     fprintf(out,"0\n");

     i=0;

     for(loop1=0; loop1<24; loop1++)
       {
       fprintf(out,"3e%02da (e%05.2f%%a):0 ",
		    loop1, (float)usedhour[loop1]/(usedtime)*100);

       for(loop2=0; loop2<((float)usedhour[loop1]/(usedtime)*100); loop2++)
	  {
	  if(coloredbars)
	    fprintf(out,"%s", COLORS[i]);
	  else
	    fprintf(out,"");

	  if(i>12)
	     i=-1;
	  i++;
	  }

       fprintf(out,"\n");
       }

     fprintf(out,"\n");
     }

   if(dayusage)
     {
     fprintf(out,"3ePercent Usage a(eby daya)\n");
     fprintf(out,"0\n");

     i=0;

     for (loop1=0; loop1<7; loop1++)
       {
       fprintf(out,"3e%-9sa (e%05.2f%%a): ", DAYS[loop1], (float)usedday[loop1]/(usedtime)*100);

       for (loop2=0; loop2<((float)usedday[loop1]/(usedtime)*100); loop2++)
	   {
	   if(coloredbars)
	     fprintf(out,"%s", COLORS[i]);
	   else
	     fprintf(out,"");

	   if (i>12)
	      i=-1;
	   i++;
	   }

       fprintf(out,"\n");
       }

     fprintf(out,"\n");
     }
/*
     fprintf(out,"3ePercent Usage a(eby weeka)\n");
     fprintf(out,"0\n");

     i=0;

     for (loop1=0; loop1<curweek; loop1++)
       {
       fprintf(out,"3eWeek# %da (e%05.2f%%a): ", loop1, (float)(utimetbl[loop1].usedtime/usedtime)*100);

       for (loop2=0; loop2<((float)utimetbl[loop1].usedtime/(usedtime)*100); loop2++)
	   {
	   if(coloredbars)
	     fprintf(out,"%s", COLORS[i]);
	   else
	     fprintf(out,"");

	   if (i>12)
	      i=-1;
	   i++;
	   }

       fprintf(out,"\n");
       }
     fprintf(out, "\n");
*/

   if(usersect)
     {
     fprintf(out,"3eUsername                  time  calls drop  read  post   p/c anon  u/l  d/l\n");
     if(twolineuser)
	 fprintf(out,"                      time/call crash chat %%usage\n");
     fprintf(out,  "a         0\n");

     for(loop1=0; loop1<numusr; loop1++)
       if(user[loop1].calls>seeuser && !user[loop1].excl)
       {
       fprintf(out,"%-24.24s %3ld:%02ld %5u %4u %6u %4u %5.2f %4u %4u %4u\n",
	   user[loop1].name, user[loop1].timeon/60L/60L,
	   user[loop1].timeon/60L % 60L, user[loop1].calls,
	   user[loop1].carrierd, user[loop1].umread, user[loop1].umenter,
	   ((float)user[loop1].umenter/user[loop1].calls), user[loop1].anon,
	   user[loop1].upload, user[loop1].download);

       if(twolineuser)
	 fprintf(out,"                          %2ld:%02ld %5u %4u %6.2f\n",
	     ((user[loop1].timeon/user[loop1].calls)/60L/60L),
	     ((user[loop1].timeon/user[loop1].calls)/60L % 60L),
	     user[loop1].crash, user[loop1].uchats,
	     ((float)user[loop1].timeon/usedtime*100));
       }

     fprintf(out,"\n");
     }

   if(nodesect)
     {
     fprintf(out,"3eNodename                   time  calls busy  read  post   dup   exp ofetch\n");
     fprintf(out,  "a        0\n");
     for(loop1=0; loop1<numnet; loop1++)
       fprintf(out,"%-25.25s %3ld3a:0%02ld %5ld %4ld %5ld %5ld %5ld %5ld %5ld\n",
	   network[loop1].name, network[loop1].timeon/60/60,
	   network[loop1].timeon/60 % 60, network[loop1].calls,
	   network[loop1].busy, network[loop1].nmread,
	   network[loop1].nmenter, network[loop1].nmduplicate,
	   network[loop1].nmexpired, network[loop1].ofetch);

     fprintf(out,"\n");
     }

   if (newusr && onetimecaller)
   {
       fprintf(out,"3eOne time callers\n");
       fprintf(out,"a0\n");
       for (loop1=0,loop2=0; loop1<numusr; loop1++)
           if (user[loop1].new)
           {
	       fprintf(out,"%-20.20s    ", user[loop1].name);
	       loop2++;
	       if (loop2 % 3==0)
		   fprintf(out,"\n");
	   }
       if(loop2 % 3==0)
	 fprintf(out,"\n");
       else
	 fprintf(out,"\n\n");
   }

   if(awards)
     {
     fprintf(out,"3eAwards\n");
       fprintf(out,"a0\n");

     for(loop1=0, loop2=0; loop1<numusr; loop1++)
	 if(user[loop1].umenter > user[loop2].umenter)
	     loop2=loop1;

     fprintf(out,"3eMost messages entereda..:0 %-25.25s with %u of um.\n",
		  user[loop2].name, user[loop2].umenter);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
	 if ((user[loop1].umenter/user[loop1].calls*10) > (user[loop2].umenter/user[loop2].calls*10))
	    loop2=loop1;

     fprintf(out,"3eMost posts per calla....:0 %-25.25s with %f.\n",
	   user[loop2].name, (float)user[loop2].umenter/user[loop2].calls);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].umread > user[loop2].umread)
           loop2=loop1;

     fprintf(out,"3eMost messages reada.....:0 %-25.25s with a whopping %u.\n",
	   user[loop2].name, user[loop2].umread);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
	if(user[loop1].anon > user[loop2].anon)
	   loop2=loop1;

     fprintf(out,"3eMost Anonymous messagesa:0 %-25.25s with %u.\n",
	   user[loop2].name, user[loop2].anon);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].upload > user[loop2].upload)
           loop2=loop1;

     fprintf(out,"3eMost files uploadeda....:0 %-25.25s with %u uploads.\n",
	   user[loop2].name, user[loop2].upload);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].download > user[loop2].download)
           loop2=loop1;

     fprintf(out,"3eMost files downloadeda..:0 %-25.25s with %u leaches.\n",
	   user[loop2].name, user[loop2].download);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].uchats > user[loop2].uchats)
           loop2=loop1;

     fprintf(out,"3eMost chat requestsa.....:0 %-25.25s with %u annoying chats\n",
	   user[loop2].name, user[loop2].uchats);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].timeon > user[loop2].timeon)
           loop2=loop1;

     fprintf(out,"3eMost time on systema....:0 %-25.25s with %ld3a:0%02ld (wooow)\n",
       user[loop2].name, user[loop2].timeon/60/60, user[loop2].timeon/60 % 60);

     for (loop1=0, loop2=0; loop1<numusr; loop1++)
       if (user[loop1].carrierd > user[loop2].carrierd)
	   loop2=loop1;

     fprintf(out,"3eMost dropped carriersa..:0 %-25.25s with %u.\n",
       user[loop2].name, user[loop2].carrierd);

     }
}

/****************************************************************************/
/* parseargs...  deals with the command line options...                     */
/****************************************************************************/
void parseargs(int argc, char *argv[])
{
int i = 3;
char badarg=0;

while(i<argc)
  {
  switch (toupper(argv[i][1]))
    {
    case '1':
	if(argv[i][2]=='+')
	  onetimecaller=1;

	if(argv[i][2]=='-')
	  onetimecaller=0;

	break;
    case 'B':
	if(argv[i][2]=='+')
	  coloredbars=1;

	if(argv[i][2]=='-')
	  coloredbars=0;

	break;
    case 'C':
	if(argv[i][2]=='+')
	  color=1;

	if(argv[i][2]=='-')
	  color=0;

	break;
    case 'D':
	debug=1;
	break;
    case 'U':
	if(argv[i][2]=='+')
	  twolineuser=1;

	if(argv[i][2]=='-')
	  twolineuser=0;

	break;
    case '#':
	seeuser = atol(argv[i]+2);
	break;
    case 'S':
	if(strlen(argv[i]) == 5)
	{
	/* figure out the user sort option */
	switch (toupper(argv[i][2]))
	  {
	  case 'A':
		usersort='A';
		break;
	  case 'T':
		usersort='T';
		break;
	  case 'L':
		usersort='L';
		break;
	  case 'R':
		usersort='R';
		break;
	  case 'E':
		usersort='E';
		break;
	  case 'P':
		usersort='P';
		break;
	  case 'U':
		usersort='U';
		break;
	  case 'D':
		usersort='D';
		break;
	  case 'C':
		usersort='C';
		break;
	  default:
		printf("Bad user sort option \"%c\".", argv[i][2]);
		badarg=1;
		break;
	  }
	/* and then figure out the network sort option */
	switch(toupper(argv[i][3]))
	  {
	  case 'A':   /* alpha */
		networksort='A';
		break;
	  case 'B':   /* busy signals */
		networksort='B';
		break;
	  case 'C':   /* calls */
		networksort='C';
		break;
	  case 'D':   /* duplicates */
		networksort='D';
		break;
	  case 'E':   /* expired */
		networksort='E';
		break;
	  case 'P':   /* posts */
		networksort='P';
		break;
	  case 'R':   /* read */
		networksort='R';
		break;
	  case 'T':   /* time on */
		networksort='T';
		break;
	  default:
		printf("Bad second sort option \"%c\".", argv[i][3]);
		badarg=1;
		break;
	  }
	/* and finally figure out the protocol sort option */
	switch(toupper(argv[i][4]))
	  {
	  case 'A':
		protosort='A';
		break;
	  case 'U':
		protosort='U';
		break;
	  case 'D':
		protosort='D';
		break;
	  default:
		printf("Bad third sort option \"%c\".", argv[i][4]);
		badarg=1;
		break;
	  }
	}
	else
	{
	  printf("Wrong number of args in sort option. (must be \"-S123\".)\n");
	}
	break;
    default:
	printf("unknown command line option \"%s\".\n", argv[i]);
	badarg=1;
	break;
    }
  i++;
  }

/* ugly, isn't it?  yuck...oh well. */

if(badarg)
  exit(1);
}

/****************************************************************************/
/* filter() -- filters all the ^A codes out of the output file.             */
/****************************************************************************/
void filter(char *argv[])
{
unsigned char ch=0, lch=0;
FILE *in, *out;

  in = fopen(tempname, "rb");
  out = fopen(argv[2], "wb");

  while(!feof(in))
    {
    lch=ch;
    ch = getc(in);

    if(ch == '' || lch == '')
      ;
    else
      putc(ch, out);
    }

  fcloseall();
}

/****************************************************************************/
/* debug_out() -- makes a debug output file...  wow.			    */
/****************************************************************************/
void debug_out(void)
{
   int loop1=0;

   if ((debugout = fopen("debug.out", "at")) == NULL)
   {
       printf("\n Can't open \"debug.out\" for output.\n");
       fcloseall();
       exit(-1);
   }

   fprintf(debugout,"5\n");
   fprintf(debugout,"version = %s\n\n", version);

   fprintf(debugout,"coreleft : %lu bytes\n", (unsigned) coreleft());

   fprintf(debugout,"Free heap: %lu bytes\n", (unsigned long) coreleft());


   for (loop1=0; loop1<24; loop1++)
     fprintf(debugout,"call/hour # %d = %d\n", loop1, chour[loop1]);

   fprintf(debugout,"\n");

   for(loop1=0; loop1<7; loop1++)
     fprintf(debugout,"call/day # %d (%s) = %d\n",
	     loop1, DAYS[loop1], cday[loop1]);

   fprintf(debugout,"\n");

   for(loop1=0; loop1<7; loop1++)
     fprintf(debugout,"usedday # %d (%s) = %ld\n",
	     loop1, DAYS[loop1], usedday[loop1]);

   fprintf(debugout,"\n");

   for(loop1=0; loop1<24; loop1++)
     fprintf(debugout,"usedhour # %d = %ld\n", loop1, usedhour[loop1]);

   fprintf(debugout,"\n");

   for(loop1=0; loop1<16; loop1++)
     fprintf(debugout,"usedbaud # %d (%s) = %ld\n",
	     loop1, bauds[loop1], usedbaud[loop1]);

   fprintf(debugout,"\nnumusr = %d\n", numusr);
   fprintf(debugout,"numnet = %d\n", numnet);
   fprintf(debugout,"numproto = %d\n", numproto);
   fprintf(debugout,"fdate = %ld\n", fdate);
   fprintf(debugout,"ldate = %ld\n", ldate);
   fprintf(debugout,"downtime = %ld\n", downtime);
   fprintf(debugout,"networktime = %ld\n", networktime);
   fprintf(debugout,"usedtime = %ld\n", usedtime);
   fprintf(debugout,"logins = %ld\n", logins);
   fprintf(debugout,"hangups = %ld\n", hangups);
   fprintf(debugout,"chreq = %ld\n", chreq);
   fprintf(debugout,"menter = %ld\n", menter);
   fprintf(debugout,"mread = %ld\n", mread);
   fprintf(debugout,"anon = %ld\n", anon);
   fprintf(debugout,"newusr = %ld\n", newusr);
   fprintf(debugout,"wcup = %ld\n", wcup);
   fprintf(debugout,"wcdown = %ld\n", wcdown);
   fprintf(debugout,"net (net callin) = %ld\n", net);
   fprintf(debugout,"netcall (net callout) = %ld\n\n", netcall);

   for(loop1=0; loop1<numusr; loop1++)
     fprintf(debugout,"slt:%-2d nym:%-30s nw:%d tme:%-6ld cal:%-3ld cd:%-3ld up:%-3ld dwn:%-3ld R:%-5ld E:%-4ld anon:%-4ld cht:%-4ld\n",
	     loop1, user[loop1].name, user[loop1].new, user[loop1].timeon,
	     user[loop1].calls, user[loop1].carrierd, user[loop1].upload,
	     user[loop1].download, user[loop1].umread, user[loop1].umenter,
	     user[loop1].anon, user[loop1].uchats);

   fprintf(debugout,"\n");
   for(loop1=0; loop1<numnet; loop1++)
     fprintf(debugout,"slt:%-2d nym:%-30s tme:%-6ld cal:%-3ld bsy:%-3ld E:%-5ld R:%-5ld Dup:%-4ld exp:%-4ld\n",
	     loop1, network[loop1].name, network[loop1].timeon,
	     network[loop1].calls, network[loop1].busy,
	     network[loop1].nmenter, network[loop1].nmread,
	     network[loop1].nmduplicate, network[loop1].nmexpired);

   fprintf(debugout,"\n");
   for(loop1=0; loop1<numproto; loop1++)
     fprintf(debugout,"slt:%-2d nym:%-30s up:%ld dwn:%ld\n",
	     loop1, proto[loop1].name, proto[loop1].up, proto[loop1].down);

   fclose(debugout);
}

/****************************************************************************/
/* msgstat() -- scan through message base...building message stats.         */
/****************************************************************************/
/*
void msgstat(void)
{
} */

/****************************************************************************/
/* readcfg() -- reads the config file... */
/****************************************************************************/
int readcfg(void)
{
   int i, j;
   int keywords = 17;
   int section  = 12;
   int userkey  =  9;
   int nodekey  =  8;
   int protokey =  3;
   FILE *cfg;

   static char *KEYWORD[] = {
	"COLOR",
	"COLOREDBARS",
	"SEEUSER",
	"USERSORT",
	"NETSORT",
	"PROTOCOLSORT",
	"TWOLINEUSER",
	"ONETIMECALLER",
	"OLDGRAPH",
	"OMIT",
	"EXCLUDE_USER",
	"EXCLUDE_NODE",
	"EXCLUDE_PROTOCOL",
	"DEBUG",
	"TRAPFILE",
	"OUTPUTFILE",
	"DEBUGFILE",
	"DATAFILE"
	};

   static char *USERSKEY[] = {
	"ALPHA",
	"TIME",
	"CALLS",
	"READ",
	"POSTS",
	"PCRATIO",
	"UPLOADS",
	"DOWNLOADS",
	"CHATS"
	};

   static char USER1[] = {'A','T','C','R','E','P','U','D','C'};

   static char *NETSKEY[] = {
	"ALPHA",
	"TIME",
	"CALLS",
	"READ",
	"POSTS",
	"DUPLICATE",
	"EXPIRED",
	"BUSY"
	};

   static char NET1[] = {'A','T','C','R','P','D','E','B'};

   static char *PROTOSKEY[] = {
	"ALPHA",
	"UPLOADS",
	"DOWNLOADS"
	};

   static char PROTO1[] = {'A','U','D'};

   static char *SECTKEY[] = {
	"uptime",
	"totals",
	"usage",
	"averages",
	"trap",
	"proto",
	"hours",
	"days",
	"firstime",
	"users",
	"nodes",
	"awards"
      };

    if ((cfg = fopen (configfile, "rt")) == 0)
      {
	printf ("No config file present.\n");
	return 0;
      }
    else
      {
	printf("Config file \"%s\" found.\n", configfile);
      }

    while (!feof (cfg))
      {
	text = fgets(line, sizeof(line), cfg);
	if(text == 0)
	   break;
	if(line[0] != '#')
	   continue;

	i = sscanf(line, "%s \"%255[^\"\n\r\t]", word1, lword1);

	if(i == 1)
	   i = sscanf(line, "%s %255s", word1, lword1);
	if(i != 2)
	   continue;

	for(i = 0; i < keywords+1; i++)
	    if(stricmp(&word1[1], KEYWORD[i]) == 0)
	       break;

        switch (i)
          {
          case 0:
		 if((stricmp(lword1, "off") == 0) || (atoi(lword1) == 0))
		    {
		    color=0;
		    printf("Color off\n");
		    }
		 break;
	  case 1:
		  if((stricmp(lword1, "off") == 0) || (atoi(lword1) == 0))
		     {
		     coloredbars=0;
		     printf("Colored Bars off\n");
		     }
		  break;
	  case 2:
		  seeuser = atol(lword1);
		  if(seeuser > 1)
		    printf("User's with %ld calls listed\n", seeuser);
		  break;
	  case 3:
		  for(j = 0; j < userkey+1; j++)
		  if(stricmp(lword1, USERSKEY[j]) == 0)
		     {
		     usersort = USER1[j];
		     break;
		     }
		  if(j > userkey)
		     printf("Unknown user sort option \"%s.\"\n", lword1);
		  printf("Users sorted by %s.\n", USERSKEY[j]);
		  break;
	  case 4:
		  for(j = 0; j < nodekey+1; j++)
		  if(stricmp(lword1, NETSKEY[j]) == 0)
		     {
		     networksort = NET1[j];
		     break;
		     }
		  if(j > nodekey)
		     printf("Unknown network sort option \"%s.\"\n", lword1);
		  printf("Nodes sorted by %s.\n", NETSKEY[j]);
		  break;
	  case 5:
		  for(j = 0; j < protokey+1; j++)
		  if(stricmp(lword1, PROTOSKEY[j]) == 0)
		     {
		     protosort = PROTO1[j];
		     break;
		     }
		  if(j > protokey)
		     printf("Unknown protocol sort option \"%s.\"\n", lword1);
		  printf("Protocols sorted by %s.\n", PROTOSKEY[j]);
		  break;
	  case 6:
		if((stricmp(lword1, "off") == 0) || (atoi(lword1) <= 0))
		   {
		   twolineuser=0;
		   printf("Suppress extended user information.\n");
		   }
		break;
	  case 7:
		if((stricmp(lword1, "off") == 0) || (atoi(lword1) <= 0))
		   {
		   onetimecaller=0;
		   printf("One time caller section suppressed.\n");
		   }
		break;
	  case 8:
		if((stricmp(lword1, "on") == 0) || (atoi(lword1) >= 1))
		   {
		   oldgraph=1;
		   printf("Using old graph style.\n");
		   }
		break;
	  case 9:
		 for(j = 0; j < section; j++)
		      if(stricmp(lword1, SECTKEY[j]) == 0)
			 break;

		 switch (j)
		 {
		 case 0:
			uptime = 0;
			printf("UPTIME section excluded.\n");
			break;

		 case 1:
			totaluse = 0;
			printf("Total Useage section excluded.\n");
			break;

		 case 2:
			avuse = 0;
			printf("Average Use section excluded.\n");
			break;

		 case 3:
			avsect = 0;
			printf("Averages section excluded.\n");
			break;

		 case 4:
			trapsect = 0;
			printf("Trapfile Stats section excluded.\n");
			break;

		 case 5:
			protosect = 0;
			printf("Protocol section excluded.\n");
			break;

		 case 6:
			hourusage = 0;
			printf("Hourly usage graph excluded.\n");
			break;

		 case 7:
			dayusage = 0;
			printf("Dayly usage graph excluded.\n");
			break;

		 case 8:
			onetimecaller = 0;
			printf("Onetime Caller section excluded.\n");
			break;

		 case 9:
			usersect = 0;
			printf("User Stats section excluded.\n");
			break;

		 case 10:
			nodesect = 0;
			printf("Nodes section excluded.\n");
			break;

		 case 11:
			awards = 0;
			printf("Awards section excluded.\n");
			break;

		 default:
			printf("Report section '%s' unknown.  \n", lword1);
			break;
		 }
	    break;

	  case 10:
		numexcl++;
		if(!(excltbl = realloc(excltbl, sizeof(struct exclusion) * numexcl)))
		   {
		   printf ("Out of memory.  Unable to store %s.", lword1);
		   return 0;
		   }

		strcpy(excltbl[numexcl-1].excl, lword1);
		printf("Excluding %s.\n", excltbl[numexcl-1].excl);
		break;

	  case 11:
	  case 12:
		break;

	  case 13:
		if((stricmp(lword1, "on") == 0) || (atoi(lword1) >= 1))
		     {
		     debug=1;
		     printf("Debug mode.\n");
		     }
		break;

	  case 14:
		strcpy(infile, lword1);
		printf("Input file: %s.\n", infile);
		break;

	  case 15:
		strcpy(outfile, lword1);
		printf("Output file: %s.\n", outfile);
		break;

	  case 16:
		strcpy(debugfile, lword1);
		printf("Debug file: %s.\n", debugfile);
		break;

	  case 17:
		strcpy(datafile, lword1);
		printf("Data file: %s.\n", datafile);
		break;

	  default:
	    printf("Keyword '%s' unknown.  \n", word1);
            break;
          }
      }

    fclose(cfg);

    return 1;

}

/****************************************************************************/
/* chkexcl (nym) looks up nym in the exclusion table, returning true if   */
/* found, false if not.                                                     */
/****************************************************************************/
int chkexcl (char *nym)
    {
    int i;

    for (i = 0; i < numexcl; i++)
        if ((stricmp (nym, excltbl [i].excl)) == 0)
            return 1;

    return 0;
    }



/****************************************************************************/
/* sortfunc() takes 3rd command line arg and uses it for sorting option     */
/****************************************************************************/
int usortfunc(const void *this1, const void *that1)
{
    const struct usr *this = this1;
    const struct usr *that = that1;
    long valret=0;

    switch(usersort)
    {
    case 'A':
	valret = strcmp(this->name, that->name);
	break;
    case 'T':
	valret = that->timeon - this->timeon;
	break;
    case 'L':
	valret = that->calls - this->calls;
	break;
    case 'R':
	valret = that->umread - this->umread;
	break;
    case 'E':
	valret = that->umenter - this->umenter;
	break;
    case 'P':
	valret = ((float)(that->umenter/that->calls) - (float)(this->umenter/this->calls));
	break;
    case 'U':
	valret = that->upload - this->upload;
	break;
    case 'D':
	valret = that->download - this->download;
	break;
    case 'C':
	valret = that->uchats - this->uchats;
	break;

    default:
	break;
    }

    if(!valret)
	valret = strcmp(this->name, that->name);

    return(valret > 0L ? 1 : -1);
}

int nsortfunc(const void *this1, const void *that1)
{
    const struct net *this = this1;
    const struct net *that = that1;
    long valret=0;

    switch(networksort)
    {
    case 'A':
	valret = strcmp(this->name, that->name);
	break;
    case 'B':
	valret = that->busy - this->busy;
	break;
    case 'C':
	valret = that->calls - this->calls;
	break;
    case 'R':
	valret = that->nmread - this->nmread;
	break;
    case 'P':
	valret = that->nmenter - this->nmenter;
	break;
    case 'E':
	valret = that->nmexpired - this->nmexpired;
	break;
    case 'T':
	valret = that->timeon - this->timeon;
	break;
    default:
	break;
    }

    if(!valret)
	valret = strcmp(this->name, that->name);

    return(valret > 0L ? 1 : -1);
}
int psortfunc(const void *this1, const void *that1)
{
    const struct protocol *this = this1;
    const struct protocol *that = that1;
    long valret=0;

    switch(protosort)
    {
    case 'A':
	valret = strcmp(this->name, that->name);
	break;
    case 'U':
	valret = that->up - this->up;
	break;
    case 'D':
	valret = that->down - this->down;
	break;
    default:
	break;
    }

    if(!valret)
	valret = strcmp(this->name, that->name);

    return(valret > 0L ? 1 : -1);
}
